/***************************************************************************
                          xboard.cpp  -  description
                             -------------------
    begin                : ven fv 22 21:25:00 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef _WIN32
#pragma warning (disable : 4786)
#endif

#include "xboard.h"

XBoard::XBoard ()
  : GUIBoard()
{}

XBoard::~XBoard()
{}

void XBoard::Init(void) {}

void XBoard::printBoard(void)
{
  int Xmax = board->Xmax;

  // Print Xaxis coordinate.
  cout << "  ";
  for (int deb=0;deb<Xmax; deb++)
    cout << deb%10;
  cout << endl;
  
  int last = -1, idx=1;
  cout << "0 ";
  for (map<int, set<Object *> >::iterator it = board->cases.begin();
       it != board->cases.end(); it++) {
     int curr = it->first;
     for (int i=last; i<curr-1; i++) {
       if (i%Xmax == Xmax-1) {
	 cout << "\n" << idx%10 << " ";
	 idx++;
       }
       cout << " ";
     }
     if ((curr-1)%Xmax == Xmax-1) {
       cout << "\n" << idx%10 << " ";
       idx++;
     }
     if (it->second.size() != 0) {
       Object *obj=0;
       int priority=0;
       for (set<Object *>::iterator ite=it->second.begin();
	    ite!=it->second.end(); ite++) {
	 if (priority < getPriority((*ite)->Type())) {
	   obj = *ite;
	   priority = getPriority(obj->Type());
	 }
       }
       cout << obj->getChar();
     }
     else
       cout << "O";
     last = curr;
  }

  cout << endl << flush;
}

void XBoard::setYellowCases(set<int> *cases) {}
void XBoard::setYellowCasesFromEntryZone() {}
void XBoard::delYellowCases(void) {}

void XBoard::setKilled(int caseId, bool isMarine) {}
