/***************************************************************************
                          xcommandline.h  -  description
                             -------------------
    begin                : lun mar 04 14:59:00 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _XCOMMANDLINE_H_
#define _XCOMMANDLINE_H_

/*
  XCommandLine is the GUI interface for player interaction.
  This class takes all the input of the player and if it's a command execute it

  This class will not be used for graphical interface, this is the so-called 
  main loop with callback event in GUI library.
*/

#include "guicommandline.h"
#include "xboard.h"
#include "xcreature.h"

class QString;
class XDataStoring;

class XCommandLine : public GUICommandLine
{
public:
  XCommandLine(XBoard *xboard, XCreature *xcrea);
  ~XCommandLine(void);

  void endOfExecution(void);
  
  pair<Direction,bool> GetDirection(string txt, bool enableReuse=true);
  QString GetLevelToPlay(void);
  pair<int,pair<Direction,bool> > 
    GetCaseAndDirection(set<int> *cases, string txt, bool enableReuse=true);
  int GetCase(set<int> *cases, string txt);
  bool GetYesOrNo(string txt);
  gameType GetGameType(bool *heurisTurn, int *cheat);
  QString GetFilename(bool PbemExt=false);
  QString GetIPAdress();
  void endOfGame(string msg);

  string _getStringCases(set<int> *cases, int chunk=0);

  void printLevelInfo(QString &tit, QString &auth, QString &nar, QString &obj, 
			      QString &forc, QString &cond);
  void printLevelInfo(void);
  void Write(string w, bool isCommand=false);
  void DrawInterface(void);
  void ClearListCreatures(void);
  void ClearInfoPanel(void);
  void printPopupMessage(string msg);
  void CenterView(int caseId);
  void GetSmtpInfos(SmtpInfo *inf);

  void setObjectButtonsVisible(bool vis);

  void MainLoop(void);
};

#endif
