/***************************************************************************
                          xcreature.h  -  description
                             -------------------
    begin                : ven mar 08 21:19:00 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _XCREATURE_H_
#define _XCREATURE_H_

#include "creature.h"
#include "guicreature.h"

class XCreature : public GUICreature {
public:
  XCreature(void);
  virtual ~XCreature(void);

  void printInfo(BolterMarine *crea, bool isSelected, int loc=0);
  void printInfo(Sergeant *crea, bool isSelected, int loc=0);
  void printInfo(FlamerMarine *crea, bool isSelected, int loc=0);
  void printInfo(Genestealer *crea, bool isSelected, int loc=0);
  void printInfo(Blip *crea, bool isSelected, int loc=0);  
  void printInfo(Door *door, bool isSelected, int loc=0);
  void printInfo(Bulkhead *bulk, bool isSelected, int loc=0);
  void printInfo(EntryZone *ez, bool isSelected, int loc=0);
  void printInfo(Flame *f, bool isSelected, int loc=0);
  void printInfo(ModuleCAT *mae, bool isSelected, int loc=0);
  void printInfo(Exit *exit, bool isSelected, int loc=0);
  void printInfo(ExtensibleObject *ext, bool isSelected, int loc=0);

  void printDetailZoneInfo(EntryZone *ez);

  void * getPixmap(BolterMarine *crea, bool b);
  void * getPixmap(Sergeant *crea, bool b);
  void * getPixmap(FlamerMarine *crea, bool b);
  void * getPixmap(Genestealer *crea, bool b);
  void * getPixmap(Blip *crea, bool b);
  void * getPixmap(Door *crea, bool b);
  void * getPixmap(Bulkhead *crea, bool b);
  void * getPixmap(Flame *crea, bool b);
  void * getPixmap(EntryZone *crea, bool b);
  void * getPixmap(ModuleCAT *crea, bool b);
  void * getPixmap(Exit *crea, bool b);
  void * getPixmap(ExtensibleObject *ext, bool b);


  void Message(string msg);
private:
  void _printPosition(Object *obj);
  void _printOrientation(RealCreature *crea);
  void _printOverwatchMode(BolterMarine *crea);
};

#endif
