/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : ven fv 22 17:05:44 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef _WIN32
#pragma warning (disable : 4786)
#endif

#include <iostream>
#include <stdlib.h>
#include <string>

#include "board.h"
#include "gamemanager.h"
#include "sessionmanager.h"

#include "xboard.h"
#include "xcommandline.h"
#include "xcreature.h"
#include "nosoundsystem.h"
#include "xdatastoring.h"

#ifdef _WIN32
QString homeDir=".";
QString levelDir=".";
#else
QString homeDir = QDir::homeDirPath()+"/.spacehulk";
QString levelDir = DATA_DIR;
#endif

Board *board;
GameManager *man;
SessionManager *session;
SoundSystem *sound;
DataStoring *store;

int main(int argc, char *argv[])
{
  cout << "Welcome to the new SpaceHulk game !!" << endl;

  board = new Board();
  sound = new DummySoundSystem;

  XCreature xcrea;
  XBoard xboard;
  store = new XDataStoring();
  XCommandLine xcmd (&xboard, &xcrea);
  man = new GameManager (&xcrea, &xboard, &xcmd);
  session = new SessionManager(&xcmd);
  xcmd.getCommand("newgame");

  xcmd.MainLoop();
  
  return EXIT_SUCCESS;
}
